/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2014-2015 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *  
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: driver_if.c 122 2015-07-17 01:31:28Z ertl-honda $
 */
#include "Os.h"
#include "driver_if.h"
#include "rlin3x.h"
#include "hsbrh850f1l_device.h"
#include "taub_pwm.h"
#include "prc_sil.h"

/*
 *  IOݡȷͳ³줿TLU01
 */

/*
 * TLU01-1 : P10_11
 * TLU01-2 : P10_10
 * TLU01-3 : P10_9
 * TLU01-4 : P10_8
 * TLU01-5 : P10_7
 * TLU01-6 : P10_6
 * TLU01-7 : P9_6
 * TLU01-8 : P9_5
 */

#define TLU01_P10  0x0FC0 /* P10_11, P10_10, P10_9, P10_8, P10_7, P10_6 */
#define TLU01_P9   0x0060 /* P9_6, P9_5 */

/*
 *  ܥǥϤν
 */
void
tInitBody(void)
{
	uint16 wk;

	/* PMC10  */
	wk = sil_reh_mem((void *) PMC(10));
	wk &= ~TLU01_P10;
	sil_wrh_mem((void *) PMC(10), wk);

	/* PM10  */
	wk = sil_reh_mem((void *) PM(10));
	wk &= ~TLU01_P10;
	sil_wrh_mem((void *) PM(10), wk);

	wk = sil_reh_mem((void *) P(10));
	wk &= ~TLU01_P10;
	sil_wrh_mem((void *) P(10), wk);

	/* PMC9  */
	wk = sil_reh_mem((void *) PMC(9));
	wk &= ~TLU01_P9;
	sil_wrh_mem((void *) PMC(9), wk);

	/* PM9  */
	wk = sil_reh_mem((void *) PM(9));
	wk &= ~TLU01_P9;
	sil_wrh_mem((void *) PM(9), wk);

	wk = sil_reh_mem((void *) P(9));
	wk &= ~TLU01_P9;
	sil_wrh_mem((void *) P(9), wk);
}

#define TLU01_PORT_MIN 0
#define TLU01_PORT_MAX 7

static const uint32 tlu01_pinfo[8] ={
	0x0A0200, /* WINKER_L   */
	0x0A0400, /* WINKER_R   */
	0x0A0080, /* BREAK_LAMP */
	0x0A0800, /* HEAD_LAMP  */
	0x0A0100, /* FOG_LAMP   */
	0x0A0040, /* BACK_LAMP  */
	0x090040, /* BUZZER     */
	0x090020, /* Reserve    */
};

void
tlu01_set(uint8 no, boolean on)
{
	uint16 wk;
	uint16 pattern;
	uint32 pinfo;
	uint8  portno;

	if (!(no <= TLU01_PORT_MAX)) {
		return;
	}

	pinfo = tlu01_pinfo[no];
	pattern =  pinfo & 0xffff;
	portno  =  (tlu01_pinfo[no] >> 16);

	wk = sil_reh_mem((void *) P(portno));
	if (on) {
		wk |=  pattern;
	}
	else {
		wk &= ~pattern;
	}
	sil_wrh_mem((void *) P(portno), wk);
}

/*
 *  ̤LED
 */
void
tSetEachLED(uint8 no, boolean on)
{
	tlu01_set(no, on);
}

/*
 *  ³LEDκ
 */
#define MAX_LED_NO		6

/*
 *  LED
 */
void
tSetLED(uint32 pattern)
{
	int loop;

	for(loop = 0; loop <= MAX_LED_NO; loop++){
		if((pattern & (1 << loop)) != 0){
			tlu01_set(loop, TRUE);
		}
		else{
			tlu01_set(loop, FALSE);
		}
	}
}

void
tSetBuzzer(boolean onoff){
	uint16 wk;

	wk = sil_reh_mem((void *) P(9));
	if(onoff == TRUE){
		wk |= 1 << 6;
	}
	else {
		wk &= ~(1 << 6);
	}
	sil_wrh_mem((void *) P(9), wk);
}

/*
 *  SDBDT³UARTν
 */
void
tInitSBDBTUart(void)
{
	rlin3x_init();
}

/*
 *  SDBDT³UARTμ
 */
boolean
tReceiveSBDBTUart(unsigned char *p_str, uint32 len)
{
	return rlin3x_receive(p_str, len);
}

/*
 *  SDBDT³UART
 */
boolean
tSendSBDBTUart(unsigned char *p_str)
{
	uint16	len = strlen(p_str);
	return rlin3x_send(p_str, len);
}

/*
 *  PWMϢν
 */
void
tInitPWM(uint32 cycle_us, uint32 servo_duty_us, uint32 esc_duty_us)
{
	taub_init_pwm(cycle_us, servo_duty_us, esc_duty_us);
}

/*
 *  ܤΥǥ塼ƥѹ
 */
void
tChangeServoDuty(uint32 servo_duty_us)
{
	taub_change_servo_duty(servo_duty_us);
}

/*
 *  ESCΥǥ塼ƥѹ
 */
void
tChangeESCDuty(uint32 esc_duty_us)
{
	taub_change_esc_duty(esc_duty_us);
}

/*
 *  ESCΥǥ塼ƥѹ
 */
void
tChangeESCDuty100NS(uint32 esc_duty_100ns)
{
	taub_change_esc_duty_100ns(esc_duty_100ns);
}
